﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using GcDevicePc.GCBuffer;

namespace GcDevicePc.DeviceConfigUI
{
    public partial class Auxiliary : Form
    {
        #region 私有变量
        private HWConfig hWConfig;
        #endregion

        #region 构造函数
        public Auxiliary()
        {
            InitializeComponent();
        }

        public Auxiliary(ref HWConfig hwconfig)
        {
            InitializeComponent();
            this.hWConfig = hwconfig;
        }
        #endregion

        #region 窗口事件
        private void Auxiliary_Load(object sender, EventArgs e)
        {
            if (this.hWConfig != null)
            {
                //this.AuxHeaterNum.SelectedIndex = this.hWConfig.hwconfiginfo.u16AuxHeaterNum;
                this.AuxHeater1.Checked = this.hWConfig.hwconfiginfo.u16AuxHeater1 == 1 ? true : false;
                this.AuxHeaterName1.Text = this.hWConfig.hwconfiginfo.u16AuxHeaterName1;
                this.AuxHeaterPTemp1.Text = this.hWConfig.hwconfiginfo.u16AuxHeaterPTemp1.ToString();

                this.AuxHeater2.Checked = this.hWConfig.hwconfiginfo.u16AuxHeater2 == 1 ? true : false;
                this.AuxHeaterName2.Text = this.hWConfig.hwconfiginfo.u16AuxHeaterName2;
                this.AuxHeaterPTemp2.Text = this.hWConfig.hwconfiginfo.u16AuxHeaterPTemp2.ToString();

            }
            
        }
        #endregion

        #region 控件事件
        private void okbtn_Click(object sender, EventArgs e)
        {
            if (this.hWConfig != null)
            {
                //this.hWConfig.hwconfiginfo.u16AuxHeaterNum = this.AuxHeaterNum.SelectedIndex;.

                this.hWConfig.hwconfiginfo.u16AuxHeater = this.AuxHeater1.Checked || this.AuxHeater2.Checked ? 1 : 0;


                this.hWConfig.hwconfiginfo.u16AuxHeaterNum = (this.AuxHeater1.Checked ? 1 : 0) + (this.AuxHeater2.Checked ? 1 : 0);
                this.hWConfig.hwconfiginfo.u16AuxHeater1 = this.AuxHeater1.Checked ? 1 : 0;
                this.hWConfig.hwconfiginfo.u16AuxHeaterName1 = this.AuxHeaterName1.Text;
                this.hWConfig.hwconfiginfo.u16AuxHeaterPTemp1 = int.Parse(this.AuxHeaterPTemp1.Text);
                this.hWConfig.hwconfiginfo.u16AuxHeater2 = this.AuxHeater2.Checked ? 1 : 0;
                this.hWConfig.hwconfiginfo.u16AuxHeaterName2 = this.AuxHeaterName2.Text;
                this.hWConfig.hwconfiginfo.u16AuxHeaterPTemp2 = int.Parse(this.AuxHeaterPTemp2.Text);
            }

            this.Close();
        }
        private void vInput_Limit_MouseLeave(object sender, EventArgs e)
        {
            TextBox DeTextBox = (TextBox)sender;          
            //if(DeTextBox.Text == "")
            //{
            //    DeTextBox.Text = "0";
            //}
            ToolTip1.Show("",DeTextBox,3000);
        }
        private void vInput_Integer_Limit_TextChange(object sender, EventArgs e)
        {
            TextBox TempTextBox = (TextBox)sender;
            ushort usData;
            ushort usMaxValue = 400;
            ushort usMinValue = 0;
            if(TempTextBox.Text.IndexOf(".") > -1)
            {
                string  strData = TempTextBox.Text;
                ToolTip1.Show("输入值为整数",TempTextBox,3000);
                TempTextBox.Clear();
                TempTextBox.AppendText(strData.Substring(0,strData.Length -1));
            }
            if (ushort.TryParse(TempTextBox.Text, out usData))
            {
                if (usData > usMaxValue)
                {
                    ToolTip1.Show($"输入值为{usMinValue}-{usMaxValue}的区间内",TempTextBox,3000);
                    TempTextBox.Clear();
                    TempTextBox.AppendText(usMaxValue.ToString());
                }
                else if(usData < usMinValue)
                {
                    ToolTip1.Show($"输入值为{usMinValue}-{usMaxValue}的区间内",TempTextBox,3000);
                    TempTextBox.Clear();
                    TempTextBox.AppendText(usMinValue.ToString());
                }
                else
                {
                    TempTextBox.Clear();
                    TempTextBox.AppendText(usData.ToString());
                }
            }
	        else if(usMinValue < 0 && TempTextBox.Text == "-")
            {

            }
            else  if(TempTextBox.Text != "" && TempTextBox.Text.Length != 0)
            {
                string str = TempTextBox.Text;
                ToolTip1.Show($"输入值为{usMinValue}-{usMaxValue}的区间内",TempTextBox,3000);
                TempTextBox.Clear();
                TempTextBox.AppendText(str.Substring(0,str.Length -1));
            }
        }
        private void cancelbtn_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        #endregion
    }
}
